import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MainCharacter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MainCharacter extends Character
{
    private int shootingCounter = 10;
       
    private int direction = 1;
    
    private double vSpeed = 0;
    private double acceleration = 0.5 ;
    private int jumpStrength = 12;
        
    /**
     * Act - do whatever the MainCharacter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        KeyPres();
        checkFall();
        SpacePres();
        
        shootingCounter --;
    }
    
    private void KeyPres()
    {
       if ( Greenfoot.isKeyDown ("right"))
       {
           setImage("Red4.png");
           move(2);
           direction = -1;

           // Plaatje naar recht en lopen
        }
       if ( Greenfoot.isKeyDown ("left")){
            setImage("Red2.png");
            move(-2);
            direction = 1;
          
            // Plaatje naar links en lopen
        }
       if ( Greenfoot.isKeyDown ("up"))
       {
           setRotation(0);
           if (onGround())
           {
               jump();
           }
        }
    }
    
    private void SpacePres()
    {
        if ( Greenfoot.isKeyDown ("space")&& shootingCounter <= 0)
        {
            if (direction == 1)
            {
                getWorld().addObject (new LaserLeft(), getX()-20,getY());
            }
            if (direction == -1)
            {
                getWorld().addObject (new LaserRight(), getX()+20,getY());   
            }
            shootingCounter = 20;
        }
    }
    
    private  void jump()
    {
        vSpeed = vSpeed - jumpStrength;
        fall();        
    }   
   
    private boolean onGround()
    {
        Actor on = getOneObjectAtOffset (0, getImage().getHeight()/2 + 5 , Ground.class);
        return on != null;
    }
    
    private void checkFall()
    {
        if (onGround())
        {
            vSpeed = 0;
        }
        else
        {
            fall();
        }
    }
    
    private void fall()
    {
        setLocation ( getX(), (int)(getY() + vSpeed));
        vSpeed = vSpeed +  acceleration  ;
    }
    
    
    

 
   }

